package com.ym.mec.biz.dal.dao;

import java.util.List;
import java.util.Map;
import java.util.Set;

import com.ym.mec.biz.dal.dto.OrganFullJobResourceNumDto;
import org.apache.ibatis.annotations.Param;

import com.ym.mec.biz.dal.entity.CooperationOrgan;
import com.ym.mec.common.dal.BaseDAO;

public interface CooperationOrganDao extends BaseDAO<Integer, CooperationOrgan> {


    /**
     * 根据机构编号获取合作单位(教学点)列表
     *
     * @param organId
     * @return
     */
    List<CooperationOrgan> queryByOrganId(@Param("organId") String organId);

    /**
     * 根据合作机构编号列表获取合作机构名称
     *
     * @param organIds
     * @return
     */
    List<Map<Integer, String>> queryNameByIds(String organIds);


    List<OrganFullJobResourceNumDto> getOrganFullJobResourceNum();

    /**
     * 获取全部使用中合作单位
     * @return
     */
    List<CooperationOrgan> getAllCooperationOrgan();
}