package com.ym.mec.biz.service;

import com.ym.mec.biz.dal.dto.FinancialExpenditureDto;
import com.ym.mec.biz.dal.entity.FinancialExpenditure;
import com.ym.mec.biz.dal.page.FinancialExpenditureQueryInfo;
import com.ym.mec.common.page.PageInfo;
import com.ym.mec.common.page.QueryInfo;
import com.ym.mec.common.service.BaseService;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.List;

public interface FinancialExpenditureService extends BaseService<Long, FinancialExpenditure> {
    /**
     * @describe 导入财务支出
     * @apiNote 时光荏苒，认真工作的时间总是过得很快，而我、享受这一刻！
     * @author zouxuan
     * @date 2020/9/7
     * @time 18:31
     * @param file:
     * @return java.lang.Object
     */
    List<FinancialExpenditure> importFinancialExpenditure(MultipartFile file) throws Exception;

    PageInfo<FinancialExpenditureDto> queryFinancialExpenditurePage(FinancialExpenditureQueryInfo queryInfo);

    /**
     * @describe 批量删除
     * @apiNote 时光荏苒，认真工作的时间总是过得很快，而我、享受这一刻！
     * @author zouxuan
     * @date 2020/9/9
     * @time 11:44
     * @param ids:
     * @return void
     */
    void batchDel(String ids);
}