package com.ym.mec.biz.service;

import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * @Author Joburgess
 * @Date 2020.05.27
 */
public interface StudentServeService {

    /**
     * @describe 学生服务信息统计
     * @author Joburgess
     * @date 2020/4/10
     * @param :
     * @return void
     */
    void exercisesSituationStatistics(String monday);

    void exercisesSituationStatistics2(String monday, List<Integer> studentIds);

    /**
     * @describe
     * @author Joburgess
     * @date 2020.06.15
     * @param courseScheduleId:
     * @param studentIds:
     * @return int
     */
    Map<String, Object> checkeIsAssignHomework(Long courseScheduleId, String studentIds, Integer teacherId);

    /**
     * @describe 获取教师应布置课程编号列表
     * @author Joburgess
     * @date 2020/12/25 0025
     * @param teacherId:
     * @return java.util.Set<java.lang.Long>
     */
    Set<Long> getTeacherServeCourseIds(Integer teacherId);

    void updateExercisesSituation(Date date, List<Integer> studentIds, Integer teacherId);

    /**
     * @describe 获取与课程相关的应被服务的学员
     * @author Joburgess
     * @date 2020/12/29 0029
     * @param date:
     * @param courseId:
     * @return java.util.Set<java.lang.Integer>
     */
    Set<Integer> getStudentWithCourse(Long courseId);

}
